var _a;
import { __rest } from "tslib";
import { createWebApp, _ACTIONS_KEY as ACTIONS_KEY, _ROUTER_KEY as ROUTER_KEY, actionSdk as sdk, getWedaAPI,
// _WEDA_CLOUD_SDK as WEDA_CLOUD_SDK,
 } from '@cloudbase/weda-client';
import { runtime } from '../utils/adapter/index';
import { get as lodashGet } from 'lodash-es';
import { OFFICIAL_LIB_KEY } from '@cloudbase/cals';
import { observable } from 'mobx';
import { bindFuncObj, createComputed } from '../utils';
import * as querystring from 'query-string';
import { generateEventFlows } from '../utils/adapter/generate';
// enum EPLATFORM {
//   WEB = 'WEB',
//   /**
//    * 拼写错误
//    * 兼容性无法修改
//    */
//   MINIPROGRAM = 'MINIPROGRAME',
// }
const DEFAULT_INIT_DATA = {
    processAction: (key, action) => {
        switch (key) {
            case ACTIONS_KEY.showModal: {
                return function (obj) {
                    var _a, _b, _c;
                    const showModal = (_b = (_a = runtime[`@weapps-materials-main-${OFFICIAL_LIB_KEY}`]) === null || _a === void 0 ? void 0 : _a.actions) === null || _b === void 0 ? void 0 : _b.showModal;
                    const isMobile = (_c = app === null || app === void 0 ? void 0 : app.__internal__) === null || _c === void 0 ? void 0 : _c.isMobile;
                    if (isMobile && !isMobile() && showModal) {
                        return showModal({ data: obj, _origin: action });
                    }
                    return action(obj);
                };
            }
            case ACTIONS_KEY.showToast: {
                return function (obj) {
                    var _a, _b, _c, _d;
                    const showMessage = (_b = (_a = runtime[`@weapps-materials-main-${OFFICIAL_LIB_KEY}`]) === null || _a === void 0 ? void 0 : _a.actions) === null || _b === void 0 ? void 0 : _b.showMessage;
                    const isMobile = (_c = app === null || app === void 0 ? void 0 : app.__internal__) === null || _c === void 0 ? void 0 : _c.isMobile;
                    // pc端toast和loading为不同实例，所以展示toast时先将loading隐藏掉
                    if (isMobile && !isMobile()) {
                        (_d = app === null || app === void 0 ? void 0 : app.hideLoading) === null || _d === void 0 ? void 0 : _d.call(app);
                    }
                    if (showMessage) {
                        return showMessage({ data: obj, _origin: action });
                    }
                    return action(obj);
                };
            }
            case ACTIONS_KEY.showLoading: {
                return function (obj) {
                    var _a;
                    const isMobile = (_a = app === null || app === void 0 ? void 0 : app.__internal__) === null || _a === void 0 ? void 0 : _a.isMobile;
                    if (isMobile && !isMobile()) {
                        // pc端toast和loading为不同实例，所以展示loading时先将toast隐藏掉
                        try {
                            const message = document.getElementById('tea-message-root');
                            message.children[0].style.display = 'none';
                        }
                        catch (error) {
                            //
                        }
                        return action(obj, 'pc');
                    }
                    return action(obj);
                };
            }
        }
        return action;
    },
};
export const subPackageName = '';
let __app = undefined;
export const $w = new Proxy(((_a = __app === null || __app === void 0 ? void 0 : __app.__internal__) === null || _a === void 0 ? void 0 : _a.$w) || {}, {
    get(_, prop) {
        var _a, _b;
        if (prop === '$app' || prop === 'app') {
            return __app;
        }
        return (_b = (_a = __app === null || __app === void 0 ? void 0 : __app.__internal__) === null || _a === void 0 ? void 0 : _a.$w) === null || _b === void 0 ? void 0 : _b[prop];
    },
});
__app = createGlboalApi(DEFAULT_INIT_DATA);
export let app = __app;
export function registerApp(_app = createGlboalApi(DEFAULT_INIT_DATA)) {
    _injectApp2Runtime(_app, true);
    app = _app;
}
mountAPIs(sdk);
function createGlboalApi(initData = {}) {
    const webApp = createWebApp(initData);
    const globalAPI = new Proxy(Object.assign(webApp, Object.assign(Object.assign({ domain: initData.domain || '', state: {}, computed: {}, dataset: {}, common: new Proxy({}, {
            get(_, prop) {
                console.warn('$app.common 还未初始化完毕。应避免在低码函数外部直接对 $app.common.xxx 发起访问。');
                return _[prop];
            },
        }) }, webApp), { utils: Object.assign({}, webApp.utils), 
        /**
         * setState
         */
        setState: (userSetState) => {
            Object.keys(userSetState).forEach((keyPath) => {
                globalAPI.utils.set(globalAPI.dataset.state, keyPath, userSetState[keyPath]);
            });
        } })), {
        get: (obj, prop) => {
            if (prop === 'app' || prop === '$app') {
                return app;
            }
            else {
                return obj[prop];
            }
        },
        // set: (obj, prop, value) => {
        //   if (prop === 'app' || prop === '$app') {
        //     console.warn('$app 对象中 app/$app 为只读');
        //     return false;
        //   } else {
        //     // 修改 obj
        //     return true;
        //   }
        // },
    });
    _injectApp2Runtime(globalAPI);
    return globalAPI;
}
function _injectApp2Runtime(globalAPI, hard = false) {
    var _a;
    // 给全局挂上 mainApp/subApp
    // The global api exposed to lowcode
    if (subPackageName) {
        globalAPI.mainApp = runtime.$app;
        runtime[`$$subapp_${subPackageName}`] = globalAPI;
    }
    else {
        // 预览区调试栏可调试
        // 暴露给复合组件，代码组件来引用
        runtime.app = hard ? globalAPI : runtime.app || globalAPI;
        runtime.$app = new Proxy(runtime.app, {
            get(obj, prop) {
                return obj ? obj[prop] : undefined;
            },
            set(obj, prop, value) {
                if (obj) {
                    return (obj[prop] = value);
                }
                else {
                    return undefined;
                }
            },
        });
        runtime.$w = new Proxy($w || ((_a = globalAPI === null || globalAPI === void 0 ? void 0 : globalAPI.__internal__) === null || _a === void 0 ? void 0 : _a.$w) || {}, {
            get(_, prop) {
                var _a, _b, _c, _d;
                const $page = ((_b = (_a = runtime.app) === null || _a === void 0 ? void 0 : _a.__internal__) === null || _b === void 0 ? void 0 : _b.activePage) || runtime.$page;
                if ((_d = (_c = $page === null || $page === void 0 ? void 0 : $page.__internal__) === null || _c === void 0 ? void 0 : _c.$w) === null || _d === void 0 ? void 0 : _d[prop]) {
                    return $page.__internal__.$w[prop];
                }
                if (_[prop]) {
                    return _[prop];
                }
                return null;
            },
        });
    }
}
export function removeGlboalApi() {
    if (subPackageName) {
        runtime[`$$subapp_${subPackageName}`] = undefined;
    }
    else {
        runtime.app = undefined;
        runtime.$app = undefined;
    }
}
export function createPageApi() {
    const $page = new Proxy({
        __internal__: {
            active: false,
        },
        state: {},
        computed: {},
        handler: {},
        widgets: observable({}),
        dataset: {},
        setState: (userSetState) => {
            Object.keys(userSetState).forEach((keyPath) => {
                var _a;
                app.utils.set((_a = $page.dataset) === null || _a === void 0 ? void 0 : _a.state, keyPath, userSetState[keyPath]);
            });
        },
        setParams: (_params) => {
            var _a;
            const params = Array.isArray(_params)
                ? _params.reduce((map, meta) => {
                    var _a, _b, _c;
                    let { key, value } = meta;
                    if ((_a = key === null || key === void 0 ? void 0 : key.startsWith) === null || _a === void 0 ? void 0 : _a.call(key, '$page.')) {
                        key = key.replace(/^\$page\./, '');
                    }
                    if ((_b = key === null || key === void 0 ? void 0 : key.trim) === null || _b === void 0 ? void 0 : _b.call(key)) {
                        map[(_c = key === null || key === void 0 ? void 0 : key.trim) === null || _c === void 0 ? void 0 : _c.call(key)] = value;
                    }
                    return map;
                }, {})
                : _params;
            Object.keys(params).forEach((keyPath) => {
                var _a;
                app.utils.set((_a = $page.dataset) === null || _a === void 0 ? void 0 : _a.params, keyPath, params[keyPath]);
            });
            let queryObj;
            try {
                queryObj =
                    querystring.parse((runtime._WEAPPS_HISTORY.location.search || '').split('?')[1] || '') || {};
            }
            catch (e) {
                queryObj = Object.assign({}, (_a = $page.dataset) === null || _a === void 0 ? void 0 : _a.params);
            }
            Object.keys(params)
                .map((keyPath) => {
                const matched = keyPath.match(/(^.*?)[.[]/);
                if (matched) {
                    return matched[0];
                }
                return keyPath;
            })
                .forEach((key) => {
                var _a, _b;
                queryObj[key] = (_b = (_a = $page.dataset) === null || _a === void 0 ? void 0 : _a.params) === null || _b === void 0 ? void 0 : _b[key];
            });
            app.redirectTo({
                pageId: $page.id,
                packageName: $page.__internal__.packageName,
                params: queryObj,
            });
        },
        _dataBinds: {},
        invokeComponentMethod({ component, method, params }) {
            var _a;
            let userWidget;
            if (typeof component === 'string') {
                const widgetData = lodashGet($page.widgets, component);
                if (Array.isArray(widgetData)) {
                    throw new Error(`调用方法失败：id为${component}的组件拥有多个实例`);
                }
                userWidget = widgetData === null || widgetData === void 0 ? void 0 : widgetData._userWidget;
            }
            else {
                userWidget = component;
            }
            const action = (_a = userWidget === null || userWidget === void 0 ? void 0 : userWidget.custom) === null || _a === void 0 ? void 0 : _a[method];
            if (typeof action !== 'function') {
                throw new Error(`调用方法失败：未找到id为${userWidget === null || userWidget === void 0 ? void 0 : userWidget.sys.id}下的方法${method}`);
            }
            return action(params);
        },
    }, {
        get(obj, prop) {
            return prop === '$page' ? obj : obj[prop];
        },
    });
    return $page;
}
// 分app 和 wx 挂载app
function mountAPIs(sdks) {
    Object.keys(sdks).forEach((item) => {
        let action = sdks[item];
        if (!(item in ACTIONS_KEY) && !(item in ROUTER_KEY)) {
            app[item] = action;
        }
    });
    return app;
}
export function createCompApi({ id, ref, state = observable({}), computed = {}, _dataBinds = {}, compConfig = {}, node, events, props, handler = {}, propsData, eventFlows, }) {
    const { $w, app } = getWedaAPI() || {};
    const $comp = new Proxy({
        id,
        __internal__: {
            defaultCssUnit: undefined,
            $w: undefined,
            eventFlows: undefined,
        },
        _dataBinds,
        compConfig,
        widgets: observable({}),
        node,
        // lib: { const: constObj, tools: toolsObj },
        get props() {
            const _a = props || {}, { forwardRef } = _a, restProps = __rest(_a, ["forwardRef"]);
            return Object.assign(Object.assign({}, restProps), { events, data: propsData });
        },
        dataset: undefined,
        get state() {
            return state;
        },
        computed: {},
        get _instanceRef() {
            return ref;
        },
        get methods() {
            var _a;
            return (_a = ref.current) === null || _a === void 0 ? void 0 : _a.methods;
        },
        set methods(value) {
            if (!ref.current) {
                ref.current = {};
            }
            ref.current.methods = value;
        },
    }, {
        get: (obj, prop) => {
            return prop === '$WEAPPS_COMP' || prop === '$comp' ? obj : obj[prop];
        },
    });
    const context = {
        $w: new Proxy($w || {}, {
            get(_, prop) {
                var _a, _b, _c, _d, _e, _f;
                /**
                 * 代理可以访问到当前 page
                 */
                if (prop === '$page' || prop === 'page') {
                    return app === null || app === void 0 ? void 0 : app.__internal__.activePage;
                }
                // 代理页面级 query
                if ((_b = (_a = $comp.dataset) === null || _a === void 0 ? void 0 : _a.query) === null || _b === void 0 ? void 0 : _b[prop]) {
                    return $comp.dataset.query[prop];
                }
                // 代理页面 flow
                if ((_c = $comp.__internal__.eventFlows) === null || _c === void 0 ? void 0 : _c[prop]) {
                    return $comp.__internal__.eventFlows[prop];
                }
                // 尝试代理页面级别组件实例
                let pageWidget = (_d = $comp.widgets) === null || _d === void 0 ? void 0 : _d[prop];
                if (pageWidget) {
                    return pageWidget._userWidget;
                }
                return (_f = (_e = app === null || app === void 0 ? void 0 : app.__internal__) === null || _e === void 0 ? void 0 : _e.$w) === null || _f === void 0 ? void 0 : _f[prop];
            },
        }),
        $app: app,
        $page: new Proxy({}, {
            get(target, p) {
                var _a, _b;
                return (_b = (_a = getWedaAPI()) === null || _a === void 0 ? void 0 : _a.app.utils.getCurrentPage()) === null || _b === void 0 ? void 0 : _b[p];
            },
        }),
    };
    $comp.__internal__.$w = context.$w;
    $comp.__internal__.eventFlows = generateEventFlows(eventFlows, context, {
        isComposite: true,
        looseError: true,
        useScopeWidgetData: true,
    });
    return Object.assign($comp, {
        computed: createComputed(computed, $comp),
        handler: bindFuncObj(handler || {}, $comp),
    });
}
