// @ts-nocheck
// "react-router-dom": "^6.15.0",
import * as React from 'react';
import { Router } from 'react-router-dom';
export { Route, Navigate, Routes, useLocation } from 'react-router-dom';
export function CustomRouter({ basename, children, future, history, }) {
    let [state, setStateImpl] = React.useState({
        action: history.action,
        location: history.location,
    });
    let { v7_startTransition } = future || {};
    let setState = React.useCallback((newState) => {
        v7_startTransition && React['startTransition']
            ? React['startTransition'](() => setStateImpl(newState))
            : setStateImpl(newState);
    }, [setStateImpl, v7_startTransition]);
    React.useLayoutEffect(() => {
        history.listen(() => {
            console.log('history change', history);
            setState({ action: history.action, location: history.location });
        });
    }, [history, setState]);
    return (React.createElement(Router, { basename: basename, location: state.location, navigationType: state.action, navigator: history }, children));
}
/**
 * 问题在于，如果 Route.Component，Route.element 传入函数或 react.createElement(xxx) , 则函数变化时 pagerender 就会 remount
 * 但如果传入element 但是不变化，里面更新就有问题
 */
/* <CustomRouter history={history}>
  <React.Suspense fallback={<Loading />}>
    <Routes>
      {home && <Route path={`/${home.root || ''}`} element={<Navigate to={home.path} replace={true} />} />}
      {routes.map((route) => {
        return <Route key={route.path} path={route.path} Component={route.render} />;
      })}
      <Route path="*" element={<NotFound onNotFound={onNotFound} />}></Route>
    </Routes>
  </React.Suspense>
</CustomRouter>; */
